using System;
using System.Linq;
using Avalonia.Controls;
using Avalonia.Interactivity;
using QualTask.Models;

namespace QualTask;

public partial class AuthWindow : Window
{
    public AuthWindow()
    {
        InitializeComponent();
    }

    private void AuthButton_OnClick(object? sender, RoutedEventArgs e)
    {
        // Получаем данные из TextBox'ов
        string login = LoginTextBox.Text;
        string password = PasswordTextBox.Text;

        // Проверяем, что поля заполнены
        if (String.IsNullOrWhiteSpace(login) || String.IsNullOrWhiteSpace(password))
        {
            ErrorTextBlock.IsVisible = true;
            ErrorTextBlock.Text = "Все поля должны быть заполнены!";
            return;
        }

        // Проверяем, что пользователь существует
        User? user = DbService.GetContext().Users.FirstOrDefault(u => u.Login == login && u.Password == password);
        if (user == null)
        {
            ErrorTextBlock.IsVisible = true;
            ErrorTextBlock.Text = "Такого пользователь не существует!";
            return;
        }

        ErrorTextBlock.IsVisible = false;
        UserWindow wnd = new UserWindow();
        wnd.Show();
        Close();
    }

    private void RegistrationButton_OnClick(object? sender, RoutedEventArgs e)
    {
        RegistrationWindow wnd = new RegistrationWindow();
        wnd.Show();
        Close();
    }
}